# replace special characters in URL using the "%xx" escape
# when you download a file in Plone if the useragent is MSIE.
from Products.Archetypes.utils import contentDispositionHeader
from urllib import quote

def download(self, instance, REQUEST=None, RESPONSE=None, no_output=False):
    """Kicks download.
    Writes data including file name and content type to RESPONSE
    """
    file = self.get(instance, raw=True)
    if not REQUEST:
        REQUEST = instance.REQUEST
    if not RESPONSE:
        RESPONSE = REQUEST.RESPONSE
    useragent =  REQUEST['HTTP_USER_AGENT']
    MSIE = useragent.find('MSIE')
    filename = self.getFilename(instance)
    if filename is not None:
        if MSIE >= 0:
            filename=quote(filename)
        header_value = contentDispositionHeader('attachment', instance.getCharset(), filename=filename)
        RESPONSE.setHeader("Content-disposition", header_value)
    if no_output:
        return file
    return file.index_html(REQUEST, RESPONSE)

from Products.Archetypes.Field import FileField
FileField.download = download
